; The Wall INIT routine

; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

; A0 contains channel ID
; A4 contains pointer to working definition & reserved space
; A5 contains window manager vector

	section init
	include dev1_asm_wall_includes
	include dev8_keys_wwork


; window definitions & places in that defn
	xref	windef
	xref	app_pap
	xref	app_brd
	xref	hrep
	xref	appl1
	xref	shad
; action routines
	xref	act_esc
	xref	mk_btn
	xref	setseed
	xref	random
	xref	gu_achp
; pointers & sprites
	xref	cross
	xref	sp4_wall4
	xref	spriteblk
	xref	sprtblk2
; external texts
	xref	abort
	xref	errmess

; misc
	xref	chan		; channel name
	xref.l	version 	; program version
	xref	new_game		; makes new game board
	xref	ssprite 	; redraws the 'the wall' sprite

	xdef	jname		; name of this job


debut	bra.s	start
	dc.l	'w.l.'
	dc.w	$4afb
jname	dc.w	name2-*-2
name	DC.B	'The Wall'
name2
	DC.L	 version
	DC.W	'PROGRAM & DOCUMENTATION  (C) W. LENERZ 2000-2016'
	DC.W	' TODOS DERECHOS RESERVADOS EN TODOS PAISES'

start	move.l	a6,a0		; a0= end of code
	add.l	a4,a0		; a0= start of dataspace
	move.l	a7,a1
	subq.l	#4,a1
	moveq	#0,d0
init_lp5
	move.l	d0,(a0)+	; clear our dataspace
	cmp.l	a0,a1
	bgt.s	init_lp5
	move.l	a4,a5		; point to end of dataspace
	moveq	#-1,d1
	moveq	#-1,d2
	moveq	#$10,d0
	trap	#1		; read screen mode
	move.b	d1,d7		; keep mode
	cmp.b	#8,d1
	blt.s	initlb1
	moveq	#0,d1
	move.b	#4,d7
	moveq	#$10,d0
	trap	#1		; set mode to 4 if <> 4
initlb1 move.l	a5,a4
	add.l	a6,a4		; a4= points to dataspace now
	lea	chan,a0
	moveq	#1,d0
	moveq	#-1,d1
	moveq	#0,d3
	trap	#2
	tst.l	d0		; open window
	bne	act_esc
	move.l	a0,a6		; a6=channel id
	move.l	a0,8(a4)		; put into working defn
	moveq	#$70,d0
	moveq	#-1,d3
	trap	#3		; is pi there?
	tst.l	d0
	bne	nowman		; no!->...
	move.l	a1,d0		; is wm there?
	beq	nowman		; no!->...
	move.l	a1,a5		; a5= pe vector
	move.l	a0,-(a7)
	move.l	#totmem,d0
	jsr	gu_achp 	; get mem for recording moves (back)
	move.l	a0,moves(a4)	; pointer to my mem
	move.l	a0,current(a4)	; and here
	move.l	a0,a2		; a2 = ptr to my mem
	move.l	(a7)+,a0
	move.l	a2,a1
	moveq	#0,d2
	moveq	#$6c,d0 	; find wdw limits
	trap	#3
	tst.l	d0
	bne	act_esc 	; ooops!
	move.l	#$160016,d7	; preset big tile size
	move.w	2(a1),d0
	sub.w	#ysize,d0	; is wdw big enough?
	bpl.s	draw		; yes->....
	move.l	#$160012,d7	; preset small tile size
	lea	windef+2,a3	; and change the wdw definition to smaller size
	move.w	#250,(a3)
	lea	hrep+2,a3
	move.w	#250,(a3)
	lea	appl1+2,a3
	move.w	#250-28,(a3)
	lea	sprtblk2,a3	; sprite block for smaller screen
	move.l	a3,d0
	lea	spriteblk,a3
	sub.l	a3,d0
	move.l	d0,(a3) 	; make relative ptr to sprite block
	lea	shad,a3
	move.w	#0,(a3)
draw	lea	windef,a3
	lea	status(a4),a1
	jsr	4(a5)		; setup wdw
	lea	rndnbr(a4),a3
	jsr	setseed 	; set seed for rnd nbr generator
	jsr	new_game		; set up new game board
	lea	windef,a3
	lea	status(a4),a1
	move.l	d7,spr_x(a4)	; sprite size
	jsr	$c(a5)		; draw managed window
	jsr	$1c(a5) 	; draw window contents(w/o appsub win)
	move.w	#20,timeout(a4) ; (later, user can change this ? )
				; nyi
rdptr	moveq	#0,d3		; just to make sure
	move.w	timeout(a4),d3	; timeout
	moveq	#0,d2		; no events
	move.l	(a4),a1 	; pointer to status area
	jsr	$78(a5) 	; read pointer
is_com	tst.l	d0
	beq.s	rdptr		; ok->...
	cmp.w	#btn_err,d0	; zzz button clicked?
	beq.s	button		; yes->...
	cmp.l	#-1,d0		; timeout?
	bne.s	bad		; no, so genuine error ->...
	jsr	ssprite 	; redraw "the wall" sprite
	bra.s	rdptr		; and go around again

button	jsr	mk_btn		; make the button & read ptr etc...
	bra.s	rdptr		; and go around again

; oops, an unrecoverable error occurred - tell it all!

bad	move.l	d0,-(a7)
	jsr	$14(a5) 	; unset working defn
	moveq	#-1,d3
	moveq	#$20,d0
	trap	#3		; clear wdw
	lea	abort,a1
	move.w	(a1)+,d2
	moveq	#7,d0
	trap	#3		; abort message
	move.l	(a7)+,d0
	move.w	$cc,a2
	jsr	(a2)		; show error
	moveq	#1,d0
	trap	#3		; wait for user to hit a key

; no ptrgen or wman : complain
nowman	lea	errmess,a1
print_out
	move.w	(a1)+,d2
	moveq	#-1,d3
	moveq	#7,d0
	trap	#3
	bra	act_esc 	; and leave


	end
