; Scroll the "Wall" Sprite.
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

; this routine lets the 'The Wall' sprite scroll on the screen. This is achieved
; by changing the pointers within the sprite header. The actual sprite data is
; there twice in a row, so by increasing the pointers to the data & the mask,
; the sprite seems to scroll up...
; Once the sprite has scrolled up nearly entirely, we change the pointers back
; to the beginning
; For this sprite, one "row" for the sprite takes 16 bytes, we move it up by
; 2 rows each time (32 bytes)
;
; v. 1.00
;
	section ssprite

	xdef	ssprite

	xref	sp4_wall4	; "the wall" sprite


	include dev1_asm_wall_includes
	include dev1_asm_incl_keys_wman_wwork

ssprite movem.l d1-d7/a0-a6,-(a7)
	moveq	#0,d1		; info wdw nbr, (also presets y origin)
	moveq	#-1,d2		; only set wdw area
	jsr	$58(a5) 	; set wdw to info wdw#0, which just contains the sprite
	lea	sp4_wall4,a1	; pointer to sprite (header)
	move.w	wallcount(a4),d0  ; how often we did this already
	cmp.b	#23,d0		; nearly entirely up?
	bge.s	dim		; yes, reset the ptrs to start
	add.l	#32,12(a1)	; change pointers into sprite data!
	add.l	#32,16(a1)
	addq.w	#2,d0		; show two more rows up
	bra.s	drawspr
dim	sub.l	#384,12(a1)	; reset to beginning of sprite
	sub.l	#384,16(a1)
	moveq	#0,d0		; none scrolled yet
drawspr move.w	d0,wallcount(a4)	;
	move.w	#6*28+sprorg,d1 ; x origin of this sprite
	swap	d1		; y origin = 0
	moveq	#-1,d3
	moveq	#$76,d0
	trap	#3		; (re)draw sprite
	movem.l (a7)+,d1-d7/a0-a6
	rts


	end
