; the Wall window definition
; copyright (C) W. Lenerz 2000-2016, see the accompanying licence_txt file.

	section wdef

	include dev1_asm_wall_includes
	include dev1_asm_incl_keys_k
	include dev8_keys_wman

	xdef	windef
	xdef	hrep
	xdef	appl1
	xdef	shad
; item action routines
	xref	act_esc
	xref	act_zzz
	xref	act_move
	xref	act_new
	xref	act_back
	xref	act_minus
	xref	act_plus
; application sub wdw routines
	xref	app_draw
	xref	app_hit

	xref	jname
; sprites
	xref	cross		; pointer sprite
	xref	sp4_wall
	xref	sp4_wall4
	xref	sp4_indic1
	xref	sp4_new2
	xref	sp4_back4
	xref	sp4_minus
	xref	sp4_plus
	xref	sp4_move2
	xref	sp4_esc
	xref	sp4_zzz2
; these remain normally unchanged
lxs	EQU	24
lys	EQU	12
rays	EQU	24

; change these to suit size
titlen	EQU	8		; number of chars in title
;xsize	EQU	410		; x size of window (should be / 4)
;ysize	EQU	298		; y size of window
nbrits	EQU	2		; max nbr of items in one corner
mbarxorg  EQU	nbrits*lxs+2	; x orig of menu bar

; these are used for calculations

temp2	EQU	mbarxorg*2
mbarlen EQU	xsize-temp2-4	; rem length of menu bar
titwinxs	EQU	titlen*6+4
temp3	EQU	xsize-titwinxs
temp4	EQU	temp3/2

windef	dc.w	xsize		; default window x size
	dc.w	ysize		;	      y size
;	 dc.l	 0
	dc.w	lys		 ;initial pointer x position
	dc.w	20		;	       y position
shad	dc.b	$00		; MSbit clear to clear window
	dc.b	2		; shadow depth
	dc.w	1		; border width
	dc.w	7		; border colour
	dc.w	0		; paper colour
	dc.w	cross-* 	; pointer to pointer sprite

; menu item attributes
	dc.w	0		; current item border width
	dc.w	0		;	    border colour

; menu item unavailable:
	dc.w	7		; background colour
	dc.w	4		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob
; menu item available  :
	dc.w	7		; background colour
	dc.w	0		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob
; menu item selected   :
	dc.w	4		; background colour
	dc.w	0		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob

; possible help window
	dc.w	0		; pointer to help window
;base of repeated part of window definition
hrep	dc.w	xsize		; x (min.) size for this layout
	dc.w	ysize		; y (min.) size for this layout
;pointers to definition lists :
	dc.w	info-*		; information sub-windows
	dc.w	loose-* 	; loose items
	dc.w	appl-*		; application sub-windows
;
	dc.w	-1		; end flag
;



;Information sub-window definition list :
;========================================

;
;Information sub-window No. 0  (menue leiste)
info	dc.w	xsize		; sub-window x size
	dc.w	rays		; sub-window y size
	dc.w	0		; sub-window x origin
	dc.w	0		; sub-window y origin
	dc.b	0		; MSbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	0		; border colour
	dc.w	0		; paper colour
	dc.w	wall_obj-*	; pointer to information object list
	dc.w	-1

mwall	macro	xs
	dc.w	28		* xsize
	dc.w	24		* ysize
	dc.w	[xs]*28+sprorg,0 * xorg,yorg
	dc.b	2		* type
	dc.b	0		* spare
	dc.l	0		* spare if sprite
	dc.w	sp4_wall-*	* pointer to object
	endm
mwall2	macro	xs,spr
	dc.w	28
	dc.w	24
	dc.w	[xs]*28+sprorg,0
	dc.b	2
	dc.b	0
	dc.l	0
	dc.w	sp4_[spr]-*
	endm
mwall3	macro	xs
	dc.w	28		* xsize
	dc.w	24		* ysize
	dc.w	[xs]*28,0 * xorg,yorg
	dc.b	2		* type
	dc.b	0		* spare
	dc.l	0		* spare if sprite
	dc.w	sp4_wall-*	* pointer to object
	endm
wall_obj
	mwall2	0,move2 	; 0
	mwall	1		; 1
	mwall2	2,minus 	; 2
	mwall	3		; 3
	mwall2	4,plus		; 4
	mwall	5		; 5
	dc.w	56		; 6
	dc.w	24
	dc.w	6*28+sprorg,0
	dc.b	2
	dc.b	0
	dc.l	0
	dc.w	sp4_wall4-*

	mwall	8		; 7
	mwall	9		; 8
	mwall	10		; 9
	mwall	11		; 10
	mwall	12		; 11
	mwall	13		; 12

	dc.w	30		; 13
	dc.w	22
	dc.w	3*28+sprorg,2
	dc.b	2
	dc.b	0
	dc.l	0
	dc.w	sp4_indic1-*
	mwall3 0		; 14

	xref	sp4_wall2
	dc.w	26		; 15
	dc.w	24
	dc.w	xsize-26,0
	dc.b	2
	dc.b	0
	dc.l	0
	dc.w	sp4_wall2-*

	dc.w	-1


;Loose menu item definition list :
;========================================


loose	dc.w	28		; hit area   x size
	dc.w	12		;	  y size
	dc.w	0*28+sprorg	;	  x origin
	dc.w	12		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.cancel	; selection keystroke
	dc.w	sp4_esc-*	; pointer to object
	dc.w	it_esc		; item number
	dc.w	act_esc-*	; pointer to action routine

	dc.w	28		; hit area   x size
	dc.w	12		;	  y size
	dc.w	0*28+sprorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.move		; selection keystroke
	dc.w	sp4_move2-*
	dc.w	it_move 	; item number
	dc.w	act_move-*	; pointer to action routine

	dc.w	28		; hit area   x size
	dc.w	24		;	  y size
	dc.w	13*28+sprorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	k.sleep 	; selection keystroke
	dc.w	sp4_zzz2-*	; pointer to object
	dc.w	it_zzz		; item number
	dc.w	act_zzz-*	; pointer to action routine
 
	dc.w	28		; hit area   x size
	dc.w	24		;	  y size
	dc.w	11*28+sprorg	 ;	   x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	'N'		; selection keystroke
	dc.w	sp4_new2-*	; pointer to object
	dc.w	it_new		; item number
	dc.w	act_new-*	; pointer to action routine

	dc.w	28		; hit area   x size
	dc.w	24		;	  y size
	dc.w	9*28+sprorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	'<'		; selection keystroke
	dc.w	sp4_back4-*	; pointer to object
	dc.w	it_back 	; item number
	dc.w	act_back-*	; pointer to action routine

	dc.w	28		; hit area   x size
	dc.w	24		;	  y size
	dc.w	2*28+sprorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	'-'		; selection keystroke
	dc.w	sp4_minus-*	; pointer to object
	dc.w	it_minus		; item number
	dc.w	act_minus-*	; pointer to action routine

	dc.w	28		; hit area   x size
	dc.w	24		;	  y size
	dc.w	4*28+sprorg	;	  x origin
	dc.w	0		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	sprite		; object type
	dc.b	'+'		; selection keystroke
	dc.w	sp4_plus-*	; pointer to object
	dc.w	it_plus 	; item number
	dc.w	act_plus-*	; pointer to action routine
					       
	DC.W	-1

ob_esc	DC.W	3,'ESC'

; application subwdw defn list
appl	dc.w	appl1-*,0

	xdef	app_brd
	xdef	app_pap
appl1	dc.w	xsize-8
	dc.w	ysize-rays-4
	dc.w	4
	dc.w	rays+2
	dc.b	$00		; MSbit clear to clear window
	dc.b	2		; shadow depth
	dc.w	1		; border width
app_brd dc.w	2		; border colour
app_pap dc.w	0		; paper colour
	dc.w	cross-* 	; pointer
	dc.w	0		; setup routine
	dc.w	app_draw-*	; draw routine
	dc.w	app_hit-*	; hit routine
	dc.w	0		; control routine
	dc.w	0		; x sections
	dc.w	0		; y sections
	dc.b	$9		; keystroke
	dc.b	0		; empty


	END
