; typical window

	section wdef

	include dev1_asm_wall_includes
	include dev8_keys_k
	include dev8_keys_wman

	xdef	win2def
	xdef   inf1_cl
	xdef   inf1_txt

	xref	sp4_clown
	xref	won_text
	xref	cross		; pointer sprite
	xref	jname		; (about)
	xref	about

; these remain normally unchanged
lxs	equ	24
lys	equ	12
rays	equ	14

; change these to suit size
titlen	equ	8		; number of chars in title
xssze	equ	154		; x size of window (should be / 4)
yssze	equ	48		 ; y size of window
nbrits	equ	1		; max nbr of items in one corner
mbarxorg	equ	nbrits*lxs+2	; x orig of menu bar

; these are used for calculations

temp2	equ	mbarxorg*2
mbarlen equ	xssze-temp2-4	; rem length of menu bar
titwinxs equ	titlen*6+4
temp3	equ	xssze-titwinxs
temp4	equ	temp3/2

win2def dc.w	xssze		; default window x size
	dc.w	yssze		;	      y size
	dc.w	lys		 ;initial pointer x position
	dc.w	20		;	       y position
	dc.b	$00		; MSbit clear to clear window
	dc.b	2		; shadow depth
	dc.w	1		; border width
	dc.w	7		; border colour
	dc.w	0		; paper colour
	dc.w	cross-* 	; pointer to pointer sprite

; menu item attributes
	dc.w	1		; current item border width
	dc.w	7		;	    border colour

; menu item unavailable:
	dc.w	7		; background colour
	dc.w	4		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob
; menu item available  :
	dc.w	0		; background colour
	dc.w	7		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob
; menu item selected   :
	dc.w	4		; background colour
	dc.w	0		; text object ink colour
	dc.w	0		; pointer to blob for pattern
	dc.w	0		; pointer to pattern for blob

; possible help window
	dc.w	0		; pointer to help window
;base of repeated part of window definition
hrep	dc.w	xssze		; x (min.) size for this layout
	dc.w	yssze		; y (min.) size for this layout
;pointers to definition lists :
	dc.w	info-*		; information sub-windows
	dc.w	loose-* 	; loose items
	dc.w	0		; application sub-windows
;
	dc.w	-1		; end flag
;



;Information sub-window definition list :
;========================================

;
;Information sub-window No. 0  (menue leiste)
info	dc.w	mbarlen 	; sub-window x size
	dc.w	rays		; sub-window y size
	dc.w	mbarxorg		; sub-window x origin
	dc.w	0		; sub-window y origin
	dc.b	0		; MSbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	2		; border colour
	dc.w	82		; paper colour
	dc.w	0		; pointer to information object list

;Information sub-window No. 1 (big info subwindow)
	dc.w	xssze-8 	; sub-window x size
	dc.w	yssze-rays-4	; sub-window y size
	dc.w	4		; sub-window x origin
	dc.w	rays+2		; sub-window y origin
	dc.b	0		; MSbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	1		; border width
	dc.w	2		; border colour
	dc.w	0		; paper colour
	dc.w	inf1_obj-*	; pointer to information object list


; info window 2 (with title)
	dc.w	titwinxs		; hit area  x size
	dc.w	12		;	  y size
	dc.w	temp4		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; MSbit clear to clear window
	dc.b	0		; shadow depth
	dc.w	0		; border width
	dc.w	2		; border colour
	dc.w	0		; paper colour
	dc.w	title_obj-*	; pointer to information object list

	dc.w	-1

title_obj dc.w	titwinxs-4	; object x size
	dc.w	10		;	y size
	dc.w	2		;	x origin
	dc.w	1		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	7		; text ink colour
	dc.b	0		; text character x size
	dc.b	0		; text character y size
	dc.w	jname-* 	; pointer to object

	dc.w  -1


inf1_obj	dc.w	24		; object x size
	dc.w	22		;	y size
	dc.w	6		;	x origin
	dc.w	4		;	y origin
	dc.b	sprite		     ; object type
	dc.b	0		; spare
	dc.l	0		; spre for sprites
inf1_cl dc.w	sp4_clown-*	; pointer to object

	dc.w	titwinxs-30-8	 ; object x size
	dc.w	24		;	y size
	dc.w	36		;	x origin
	dc.w	8		;	y origin
	dc.b	0		; object type
	dc.b	0		; spare
	dc.w	7		; text ink colour
	dc.b	2		; text character x size
	dc.b	1		; text character y size
inf1_txt	dc.w	won_text-*	; pointer to object
	dc.w  -1



	dc.w  -1

;Loose menu item definition list :
;========================================


loose	dc.w	lxs		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	4		;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	k.cancel		; selection keystroke
	dc.w	ob_esc-*		; pointer to object
	dc.w	it_esc		; item number
	dc.w	act_esc-*	; pointer to action routine
	dc.w	lxs+2		; hit area   x size
	dc.w	lys		;	  y size
	dc.w	xssze-lxs-8	;	  x origin
	dc.w	2		;	  y origin
	dc.b	0		; object x justification
	dc.b	0		; object y justification
	dc.b	text		; object type
	dc.b	'I'		; selection keystroke
	dc.w	ob_info-*	 ; pointer to object
	dc.w	1		   ; item number
	dc.w	about-* 	;  pointer to action routine

	DC.W	-1

ob_esc	DC.W	3,'ESC'
ob_info dc.w	4,'INFO'
act_esc MOVEQ	#-1,D0
	RTS

	END
